<script>
    import { color_schemes } from "../../option_constants/color_schemes.js";
    import dayjs from "dayjs";
    import duration from "dayjs/plugin/duration";
    dayjs.extend(duration);

    export let plot_element;
    export let data;
    export let xScale;
    export let yScale;
    export let cadence;

    let intervalWidth = 30 * 60 * 60;
    $: cadence = dayjs.duration(data.cadence).asMilliseconds();
    $: intervalWidth = xScale(cadence) - xScale(0);

    // // $: intervalWidth = xScale(cadence) - xScale(0);
    // $: intervalWidth = xScale(new Date(data[1].time)) - xScale(new Date(data[0].time));

    const calculateAverage = function (array) {
        var total = 0;
        var count = 0;

        array.forEach(function (item, index) {
            if (!isNaN(item)) {
                total += item;
                count++;
            }
        });
        if (count > 0) {
            return total / count;
        } else {
            return 0;
        }
    };

    // Y-axis offsets and multiplier
    let offset = 0;
    let multiplier = 1;
    $: multiplier = plot_element.data_transforms.parameter_multiplier;
    $: offset = plot_element.data_transforms.parameter_offset;

    let offset_remove_mean = 0;
    $: {
        if (plot_element.data_transforms.parameter_offset_remove_mean) {
            offset_remove_mean = calculateAverage(
                data.datalist.map((d) => d[plot_element.data.parameter]),
            );
        } else {
            offset_remove_mean = 0;
        }
    }

    // Color parameter offsets and multiplier
    let z_parameter_offset = 0;
    let z_parameter_multiplier = 1;
    $: z_parameter_multiplier =
        plot_element.data_transforms.z_parameter_multiplier;
    $: z_parameter_offset = plot_element.data_transforms.z_parameter_offset;

    let z_parameter_offset_remove_mean = 0;
    $: {
        if (plot_element.data_transforms.z_parameter_offset_remove_mean) {
            z_parameter_offset_remove_mean = calculateAverage(
                data.datalist.map((d) => d[plot_element.data.z_parameter]),
            );
        } else {
            z_parameter_offset_remove_mean = 0;
        }
    }

    const normalizedValue = function (point, zmin, zmax, parameter, reverse) {
        let domain = yScale.domain();
        let value =
            (point[parameter] - z_parameter_offset_remove_mean) *
                z_parameter_multiplier +
            z_parameter_offset;
        let normalized_value = (value - zmin) / (zmax - zmin);
        if (reverse) {
            return 1 - normalized_value;
        } else {
            return normalized_value;
        }
    };
</script>

{#each data.datalist.filter((d) => !isNaN(d[plot_element.data.z_parameter])) as point}
    {#if plot_element.plot_options.symbol_type == "circle"}
        <circle
            cx={xScale(new Date(point.time))}
            cy={yScale(
                (point[plot_element.data.parameter] - offset_remove_mean) *
                    multiplier +
                    offset,
            )}
            r={plot_element.plot_options["symbol_width"]}
            fill={color_schemes[plot_element.plot_options.color_map](
                normalizedValue(
                    point,
                    plot_element.plot_options.color_map_domain.trim[0],
                    plot_element.plot_options.color_map_domain.trim[1],
                    plot_element.data.z_parameter,
                    plot_element.plot_options.reverse_color_map,
                ),
            )}
            stroke={plot_element.plot_options["stroke"]}
            stroke-width={plot_element.plot_options["stroke-width"]}
            stroke-opacity={plot_element.plot_options["stroke-opacity"]} />
    {:else if plot_element.plot_options.symbol_type == "rectangle"}
        <rect
            x={xScale(new Date(point.time)) -
                0.5 * plot_element.plot_options["symbol_width"]}
            y={yScale(
                (point[plot_element.data.parameter] - offset_remove_mean) *
                    multiplier +
                    offset,
            ) -
                0.5 * plot_element.plot_options["symbol_height"]}
            width={intervalWidth}
            height={plot_element.plot_options["symbol_height"]}
            fill={color_schemes[plot_element.plot_options.color_map](
                normalizedValue(
                    point,
                    plot_element["plot_options"]["color_map_domain"]["trim"][0],
                    plot_element["plot_options"]["color_map_domain"]["trim"][1],
                    plot_element.data.z_parameter,
                    plot_element.plot_options.reverse_color_map,
                ),
            )}
            stroke={plot_element.plot_options["stroke"]}
            stroke-width={plot_element.plot_options["stroke-width"]}
            stroke-opacity={plot_element.plot_options["stroke-opacity"]} />
    {/if}
{/each}

<style>
</style>
